## arcboot 0.3.3.9.woody.0

=== Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
# Copyright 2002 Guido Gnther <agx@sigxcpu.org>
#  

BUILD_DIRS=\
		arclib		\
		e2fslib/util 	\
		e2fslib/et 	\
		e2fslib		\
		ext2load	\
		tip22

all clean:
	for i in $(BUILD_DIRS); do \
		$(MAKE) -C $$i $@; \
	done

=== arclib/Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
#
CFLAGS = -O -Werror -Wall -mno-abicalls -G 0 -fno-pic 
ASFLAGS= -mno-abicalls -G 0 -fno-pic

OBJECTS = arc.o	stdio.o stdlib.o string.o

all:  libarc.a

libarc.a:  $(OBJECTS)
	rm -f $@
	$(AR) -cr $@ $(OBJECTS)

clean:
	rm -f libarc.a $(OBJECTS)

=== ext2load/Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
#           2001,2002 Guido Guenther <agx@sigxcpu.org>
#
EXT2_OBJS = loader.o ext2io.o conffile.o
LARC_OBJS = larc.o
OBJECTS = $(EXT2_OBJS) $(LARC_OBJS)

E2FSLIBDIR=../e2fslib

ARCLIBDIR = ../arclib
ARCLIB = $(ARCLIBDIR)/libarc.a

EXT2LIB = ../e2fslib/libext2fs.a

CFLAGS = -O -I$(ARCLIBDIR) -I$(E2FSLIBDIR) -Wall -mno-abicalls -G 0 -fno-pic 
ASFLAGS= -mno-abicalls -G 0 -fno-pic

# uncomment for debugging
#CFLAGS+=-DDEBUG

LD = ld
LDFLAGS = -N --oformat ecoff-bigmips -T ld.script

TARGETS = ext2load 

all:  $(TARGETS)

ext2load:  $(EXT2_OBJS) $(ARCLIB)
	rm -f $@
	$(LD) $(LDFLAGS) -o $@ $(EXT2_OBJS) $(EXT2LIB) $(ARCLIB)

clean:
	rm -f $(TARGETS) *.a *.o tags

=== tip22/Makefile ===
#
# Copyright 2002 Guido Guenther <agx@sigxcpu.org>
#
TFTP_OBJS = tftpload.o

ARCLIBDIR = ../arclib
ARCLIB = $(ARCLIBDIR)/libarc.a

CFLAGS = -O -I$(ARCLIBDIR) -Wall -mno-abicalls -G 0 -fno-pic 
ASFLAGS= -mno-abicalls -G 0 -fno-pic
LD = ld
LDFLAGS = -N --oformat ecoff-bigmips -T ld.script
LD_SCRIPTS = ld.kernel.script ld.ramdisk.script ld.script

LIBDIR=/usr/lib/tip22
BINDIR=/usr/sbin
LIBS=${TFTP_OBJS} ${LD_SCRIPTS} ${ARCLIB}
BINS=tip22

TARGETS = tftpload.o

# uncomment for debugging
#CFLAGS+=-DDEBUG

all:  $(TARGETS)

clean:
	rm -f $(TARGETS) *.a *.o tags

install: ${LIBS} ${BINS}
	install -d ${PREFIX}/${LIBDIR} ${PREFIX}/${BINDIR}
	install -m 644 ${LIBS} ${PREFIX}/${LIBDIR}
	install -m 755 ${BINS} ${PREFIX}/${BINDIR}

=== debian/changelog ===
arcboot (0.3.3.9.woody.0) stable; urgency=medium

  * recompile 0.3.4 for Woody r1:
     - fix loader crashes on extfs errors
     - add tip22 (piggyback style tftp loader) needed by boot floppies
       for kernels newer then 2.4.16
  * disable debugging output

 -- Guido Guenther <agx@debian.org>  Thu, 19 Sep 2002 23:10:34 +0200

arcboot (0.3.4) unstable; urgency=low

  * don't let ext2fs errors crash the loader
  * remove dead code (larc.c)
  * Fix description, thanks Joey! (Closes: #153084)

 -- Guido Guenther <agx@debian.org>  Tue, 16 Jul 2002 01:05:49 +0200

arcboot (0.3.3) unstable; urgency=low

  * tip22 calculated the highest address of the kernel's memory image
    wrong - fixed
  * tip22 now passes everything in an append="...." statement on to the kernel's
    commandline
  * improve {s,f}printf (handle "%p","%lx", be more graceful on unimplemented
    format specifiers)
  * make tip22 script more failsafe
  * removed all printing of version numbers/dates on startup
  * typo fixes, minor doc updates

 -- Guido Guenther <agx@debian.org>  Thu, 16 May 2002 00:49:28 +0200

arcboot (0.3.2) unstable; urgency=low

  * implemented "tip22" bootloader. It embeds kernel and initrd in one
    ECOFF binary. This can be used for either tftp- or CD-booting and makes
    addinitrd in the mips-tools package obselete.
  * update package built to include tip22
  * add snprintf() to arclib (needed by tip22)
  * remove snprintf() stub from ext2io.c
  * Makefile and docu cleanups
  * add a rudimentary manpage for tip22 

 -- Guido Guenther <agx@debian.org>  Thu,  9 May 2002 22:01:11 +0200

arcboot (0.3.1) unstable; urgency=low

  * move arcboot's load address 1MB upwards to let more room for larger
    kernels
  * check if the kernels in /etc/arcboot.conf are really ELF (Closes: #144728)
  * add some logic to determine the vh arcboot should go into in arcboot.config
  * update TODO

 -- Guido Guenther <agx@debian.org>  Sat, 23 Feb 2002 20:21:50 +0100

arcboot (0.3) unstable; urgency=low

  * update manpage, README and package description
  * disable debugging output

 -- Guido Guenther <agx@debian.org>  Sun, 10 Feb 2002 20:04:55 +0100

arcboot (0.2) unstable; urgency=low

  * close ITP (Closes: #119163)
  * the diff was far larger than the .orig.tar.gz so make this a
    debian native package
  * add debconf dependency
  * update manpage 
  * apply patch from Flo <flo@rfc822.org> with an updated linker scipt
    removing the mips-tools dependency
  * generate /etc/arcboot.conf if it doesn't exist

 -- Guido Guenther <agx@debian.org>  Sat,  9 Feb 2002 02:30:04 +0100

arcboot (0.1-3) experimental; urgency=low

  * replace "\n" by "\n\r" for proper output on serial consoles
  * apply patch from Florian Lohoff to fix bad OSLoadFilename
    and formatting
  * use elf2ecoff to convert arcboot into an ecoff image
  * if OSLoadOptions starts with "/" it's a kernel name otherwise
    a label in arcboot.conf
  * remove shlibs from Depends in control file
  * change loadaddress of the bootloader 0x8820f000
  * add cacheflush before jumping into the kernel
  * add debconf frontend
  * add missing -d in dvhtool call to /usr/sbin/arcboot
  * finally remove run.S and disable larc build

 -- Guido Guenther <agx@debian.org>  Fri,  8 Feb 2002 23:42:18 +0100

arcboot (0.1-2) unstable; urgency=low

  * added config file parsing (an example is in /u/s/d/arcboot/examples)
  * added a small script to move arcboot into the volume header

 -- Guido Guenther <agx@debian.org>  Sun, 18 Nov 2001 18:09:49 +0100

arcboot (0.1-1) unstable; urgency=low

  * Initial Release.
  * warning fixes
  * make memset & free return the same values as the libc versions
  * build with -mno-abicalls -G 0 -fno-pic, so the prom can deal with it
  * use basically the kernel's linker script to link arcboot
  * move all addresses into KSEG0
  * IP22 is ARCS not ARC (MEMORYTYPE in arc.h)
  * IP22 is big endian (LARGEINTEGER in arc.h)
  * remove run.S and call the kernel entry via a C function call
  * add everything that is needed from e2fsprogs so we can build
    a libe2fs with -fnopic -mno-abicalls -G 0
  * make sure arcboot doesn't use the system ext2fs header files

 -- Guido Guenther <agx@debian.org>  Mon, 12 Nov 2001 00:21:31 +0100

=== debian/control ===
Source: arcboot
Section: admin
Priority: optional
Maintainer: Guido Guenther <agx@debian.org>
Build-Depends: debhelper (>> 3.0.0)
Build-Conflicts: e2fslibs-dev
Standards-Version: 3.5.2

Package: arcboot
Architecture: mips
Depends: dvhtool, debconf (>= 0.5)
Description: Bootloader for SGI/MIPS IP22 machines
 arcboot is a bootloader for SGI/MIPS IP22 machines like the Indy or Indigo2.
 It is able to boot the Linux kernel from ext2 and ext3 filesystems which makes
 putting the kernel into the volume header obsolete.
 It is currently not capable of booting IRIX or to boot from iso9660 CDROMs though.

Package: tip22
Architecture: mips
Depends: binutils | binutils-multiarch
Description: Tftp bootimage builder for SGI/MIPS IP22 machines
 tip22 is used to merge kernel and initrd into one bootable ecoff image. This
 image also contains a small bootloader that copies the kernel to it's
 loadaddress and appends the ramdisk. This is useful for booting via tftp or
 from a CDROM. It is currently targeted for the IP22 subarchitecture but support
 for other subarchitectures and output formats can easily be added.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
export DH_COMPAT=3

PREFIX_ARCB=${CURDIR}/debian/arcboot
PREFIX_TIP22=${CURDIR}/debian/tip22

architecture=$(dpkg --print-architecture)

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir

	# Add here commands to compile the package.
	make
	cp ext2load/ext2load arcboot.raw

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean
	-rm -f arcboot.raw

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# install arcboot into debian/arcboot
	install -m 644 arcboot.raw ${PREFIX_ARCB}/usr/lib/arcboot/arcboot.raw
	install -m 755 scripts/arcboot ${PREFIX_ARCB}/usr/sbin/arcboot

	# install tip22 into debian/tip22
	make PREFIX=${PREFIX_TIP22} -C tip22 install

# Build architecture-independent files here.
binary-indep: build install
# nothing to do

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdebconf -parcboot -ptip22
	dh_installdocs -parcboot -ptip22
	dh_installexamples etc/arcboot.conf -parcboot
	dh_installexamples tip22/kernel/ -ptip22
	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
	dh_installman -parcboot -ptip22
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs -parcboot -ptip22
	dh_link -parcboot -ptip22
	dh_strip -parcboot -ptip22
	dh_compress -parcboot -ptip22
	dh_fixperms -parcboot -ptip22
#	dh_makeshlibs
	dh_installdeb -parcboot -ptip22
#	dh_perl
	dh_shlibdeps -parcboot -ptip22
	dh_gencontrol -parcboot -ptip22
	dh_md5sums -parcboot -ptip22
	dh_builddeb -parcboot -ptip22

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## arcboot 0.3.8.1

=== Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
# Copyright 2002-2004 Guido Guenther <agx@sigxcpu.org>
#  

# default subarch
SUBARCH=IP22

SUBARCH_INDEP_DIRS=\
		arclib		\
		e2fslib/util 	\
		e2fslib/et 	\
		e2fslib


# these contain subarch dependent files
SUBARCH_DIRS=\
		common		\
		ext2load	\
		tip22

all: build-subarch-indep build-subarch

build-subarch:
	set -e;			      	    \
	for i in ${SUBARCH_DIRS}; do        \
		${MAKE} -C $$i SUBARCH=${SUBARCH} all;\
	done

clean-subarch:
	set -e;			            \
	for i in ${SUBARCH_DIRS}; do        \
		${MAKE} -C $$i clean;       \
	done

build-subarch-indep:
	set -e;			      	    \
	for i in ${SUBARCH_INDEP_DIRS}; do  \
		${MAKE} -C $$i all;         \
	done

clean-subarch-indep:
	set -e;			      	    \
	for i in ${SUBARCH_INDEP_DIRS}; do  \
		${MAKE} -C $$i clean;       \
	done

clean: clean-subarch clean-subarch-indep

.PHONY: build-subarch build-subarch-indep clean-subarch \
        clean-subarch-indep clean all

=== common/Makefile ===
CFLAGS = -Wall -O2 -I. -I../arclib -DSUBARCH=${SUBARCH}

TARGETS = print_loadaddr

all: $(TARGETS)

clean:
	rm -f $(TARGETS) *.a *.o tags

=== ext2load/Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
#           2001-03 Guido Guenther <agx@sigxcpu.org>
#
EXT2_OBJS = loader.o ext2io.o conffile.o
LARC_OBJS = larc.o
OBJECTS = $(EXT2_OBJS) $(LARC_OBJS)

E2FSLIBDIR=../e2fslib

ARCLIBDIR = ../arclib
ARCLIB = $(ARCLIBDIR)/libarc.a

COMMONDIR = ../common

EXT2LIB = ../e2fslib/libext2fs.a

CFLAGS = -O -I $(COMMONDIR) -I$(ARCLIBDIR) -I$(E2FSLIBDIR) 	\
         -Wall -mno-abicalls -G 0 -fno-pic			\
	 -DSUBARCH=${SUBARCH}

ASFLAGS= -mno-abicalls -G 0 -fno-pic

# uncomment for debugging
#CFLAGS+=-DDEBUG

LD = ld
LDFLAGS = -N --oformat ecoff-bigmips -T ld.script

TARGETS = ext2load 

all:  $(TARGETS)

ext2load:  $(EXT2_OBJS) $(ARCLIB) ld.script
	rm -f $@
	$(LD) $(LDFLAGS) -o $@ $(EXT2_OBJS) $(EXT2LIB) $(ARCLIB)

ld.script: ld.script.in ../common/print_loadaddr
	LOADADDR=$$(../common/print_loadaddr); 	\
	sed -e "s/@@LOADADDR@@/$$LOADADDR/" <$< >$@

clean:
	rm -f $(TARGETS) *.a *.o tags ld.script

=== tip22/Makefile ===
--- 
+++ 
@@ -1,12 +1,17 @@
 #
-# Copyright 2002 Guido Guenther <agx@sigxcpu.org>
+# Copyright 2002-2004 Guido Guenther <agx@sigxcpu.org>
 #
 TFTP_OBJS = tftpload.o
 
 ARCLIBDIR = ../arclib
 ARCLIB = $(ARCLIBDIR)/libarc.a
 
-CFLAGS = -O -I$(ARCLIBDIR) -Wall -mno-abicalls -G 0 -fno-pic 
+COMMONDIR = ../common
+
+CFLAGS = -O -I $(COMMONDIR) -I$(ARCLIBDIR) \
+         -Wall -mno-abicalls -G 0 -fno-pic \
+	 -DSUBARCH=${SUBARCH}
+
 ASFLAGS= -mno-abicalls -G 0 -fno-pic
 LD = ld
 LDFLAGS = -N --oformat ecoff-bigmips -T ld.script
@@ -17,12 +22,16 @@
 LIBS=${TFTP_OBJS} ${LD_SCRIPTS} ${ARCLIB}
 BINS=tip22
 
-TARGETS = tftpload.o
+TARGETS = tftpload.o ld.script
 
 # uncomment for debugging
 #CFLAGS+=-DDEBUG
 
 all:  $(TARGETS)
+
+ld.script: ld.script.in ../common/print_loadaddr
+	LOADADDR=$$(../common/print_loadaddr); 	\
+	sed -e "s/@@LOADADDR@@/$$LOADADDR/" <$< >$@
 
 clean:
 	rm -f $(TARGETS) *.a *.o tags

=== debian/changelog ===
arcboot (0.3.8.1) unstable; urgency=low

  * correct subarch detection for IP32

 -- Guido Guenther <agx@debian.org>  Tue,  2 Mar 2004 12:01:14 +0100

arcboot (0.3.8) unstable; urgency=low

  * add support to load 64bit kernels (by Vivien Chappelier and Ilya Volynets)
  * hack up makefile to allow for easier per subarch builds
  * debian/rules: build and include arcboot.ip32 in the package. 
  * modify arcboot script to select the correct arcboot.subarch when
    putting the loader in the volume header
  * use ext2_fs.h from e2fslib instead of linux/ext2fs.h to not depend
    on kernel headers
  * add pt translation by Bruno Rodrigues, thanks (Closes: #216392)
  * add pt_BR translation by Andre Luis Lopes, thanks (Closes: #228285)
  * add ja translaton by Hideki Yamane, thanks (Closes: #234087)

 --  Guido Guenther <agx@debian.org>  Mon,  1 Mar 2004 12:42:06 +0100

arcboot (0.3.7) unstable; urgency=low

  * postinst: call arcboot after arcboot.conf was created
  * /usr/sbin/arcboot: abort if we don't find a configuration file
  * fix typo in control file, thanks to Julien Blache <jblache at debian.org>,
    (Closes: #192810)
  * use po-debconf, patch by Christian Perrier <bubulle at ebian.org>, thanks!
    (Closes: #205819)
  * add French translation, thanks again Christian! (Closes: #206586)
  * fix "Upstream Authors(s)" in copyright file
  * reformat debian/control to 80 characters
  * bump Standards-Version to 3.6.1

 -- Guido Guenther <agx@debian.org>  Sun, 31 Aug 2003 22:53:20 +0200

arcboot (0.3.6) unstable; urgency=low

  * fix command line handling, now things like
    	boot linux root=/dev/sda1 single
    should work as expected, no need to mess with OSLoadOptions
  * fix booting arbitrary files
  	boot /vmlinux root=/dev/sda1
    will now properly boot OSLoadPartition/vmlinux
  * search for OSLoadPartition if the envvar is bogus
  * add missing prototypes, cleanup printf length modifiers
  * move some common definitions to subarch.h
  * use gcc-2.95
  * adding other 32bit IPs to arcboot is now a two line change
    in common/subarch.h
  * arcboot script now prints what it's doing
  * postrm: silent grep on new installs
  * echo 4 > debian/compat
  * Build-Depend: on debhelper (>=4)
  * Bump Standards Version to 3.5.9
  * add ${misc:Depends}

 -- Guido Guenther <agx@debian.org>  Sat, 26 Apr 2003 22:01:14 +0200

arcboot (0.3.5) unstable; urgency=low

  * relax arcboots ELF check to make it recongnize kernels built with
    newer binutils
  * make strcpy copy the trailing '\0', thanks to Florian Lohoff for the patch
  * compile version number from changelog into arcsboot/tip22
  * spelling fixes
  * minor debian/rules cleanup

 -- Guido Guenther <agx@debian.org>  Fri, 27 Sep 2002 14:06:36 +0200

=== debian/control ===
Source: arcboot
Section: admin
Priority: optional
Maintainer: Guido Guenther <agx@debian.org>
Build-Depends: debhelper (>=4.1.16), gcc-2.95
Build-Conflicts: e2fslibs-dev
Standards-Version: 3.6.1

Package: arcboot
Architecture: mips
Depends: ${misc:Depends}, dvhtool
Description: Bootloader for SGI/MIPS IP22 machines
 arcboot is a bootloader for SGI/MIPS IP22 machines like the Indy or Indigo2.
 It is able to boot the Linux kernel from ext2 and ext3 filesystems which makes
 putting the kernel into the volume header obsolete.
 It is currently not capable of booting IRIX or to boot from iso9660 CDROMs
 though.

Package: tip22
Architecture: mips
Depends: ${misc:Depends}, binutils | binutils-multiarch
Description: Tftp boot image builder for SGI/MIPS IP22 machines
 tip22 is used to merge kernel and initrd into one bootable ecoff image. This
 image also contains a small bootloader that copies the kernel to it's
 loadaddress and appends the ramdisk. This is useful for booting via tftp or
 from a CDROM. It is currently targeted for the IP22 subarchitecture but
 support for other subarchitectures and output formats can easily be added.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

realver := $(shell dpkg-parsechangelog | awk -F' ' '/^Version:/ {print $$2}' | awk -F- '{print $$1}')

PREFIX_ARCB=${CURDIR}/debian/arcboot
PREFIX_TIP22=${CURDIR}/debian/tip22

architecture=$(dpkg --print-architecture)

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.

	touch configure-stamp

build: configure-stamp build-stamp
build-stamp:
	dh_testdir

	# update the version string
	echo "#define __ARCSBOOT_VERSION__ \"${realver}\"" > common/version.h
	# build the package
	make CC=gcc-2.95 build-subarch-indep
	make clean-subarch
	make CC=gcc-2.95 SUBARCH=IP32
	cp ext2load/ext2load arcboot.ip32
	make clean-subarch
	make CC=gcc-2.95 SUBARCH=IP22
	cp ext2load/ext2load arcboot.ip22
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	-$(MAKE) clean
	-rm -f arcboot.ip22 arcboot.ip32

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# install arcboot into debian/arcboot
	install -m 644 arcboot.ip22 ${PREFIX_ARCB}/usr/lib/arcboot/arcboot.ip22
	install -m 644 arcboot.ip32 ${PREFIX_ARCB}/usr/lib/arcboot/arcboot.ip32
	install -m 755 scripts/arcboot ${PREFIX_ARCB}/usr/sbin/arcboot

	# install tip22 into debian/tip22
	make PREFIX=${PREFIX_TIP22} -C tip22 install

# Build architecture-independent files here.
binary-indep: build install
# nothing to do

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdebconf
	dh_installdocs
	dh_installexamples etc/arcboot.conf -parcboot
	dh_installexamples tip22/kernel/ -ptip22
	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## arcboot 0.3.8.4

=== common/Makefile ===
--- 
+++ 
@@ -2,7 +2,13 @@
 
 TARGETS = print_loadaddr
 
+HOSTCC=$(CC)
+HOSTCFLAGS=-Wall -O2 -DSUBARCH=$(SUBARCH)
+
 all: $(TARGETS)
+
+$(TARGETS): print_loadaddr.c subarch.h
+	$(HOSTCC) $(HOSTCFLAGS) -o $@ $<
 
 clean:
 	rm -f $(TARGETS) *.a *.o tags

=== ext2load/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright 1999 Silicon Graphics, Inc.
-#           2001-03 Guido Guenther <agx@sigxcpu.org>
+#           2001-04 Guido Guenther <agx@sigxcpu.org>
 #
 EXT2_OBJS = loader.o ext2io.o conffile.o
 LARC_OBJS = larc.o
@@ -31,7 +31,7 @@
 
 all:  $(TARGETS)
 
-ext2load:  $(EXT2_OBJS) $(ARCLIB) ld.script
+ext2load:  $(EXT2_OBJS) $(ARCLIB) ld.script ../common/subarch.h
 	rm -f $@
 	$(LD) $(LDFLAGS) -o $@ $(EXT2_OBJS) $(EXT2LIB) $(ARCLIB)

=== debian/changelog ===
arcboot (0.3.8.4) unstable; urgency=low

  * fix compilation with gcc-3.3 for tip22 also (Closes: #273951)
  * mention IP32 in arcboots package description

 -- Guido Guenther <agx@debian.org>  Mon, 27 Sep 2004 16:45:11 +0200

arcboot (0.3.8.3) unstable; urgency=low

  * fix IP32/O2 subarch detection again, I hate /proc/cpuinfo changes
  * the 'de' debconf translation was in the last upload already
    (Closes: #250572)
  * finally tested it on IP32 myself and it work{s,ed}
  * fixup linker script to work with gcc-3.3 too

 -- Guido Guenther <agx@debian.org>  Sat, 25 Sep 2004 23:32:38 +0200

arcboot (0.3.8.2) unstable; urgency=low

  * /usr/sbin/arcboot uses file so depend on it (Closes: #236970)
  * add nl debconf translation by Luk Claes, thanks (Closes: #244632)

 -- Guido Guenther <agx@debian.org>  Tue, 20 Apr 2004 10:30:14 +0200

=== debian/control ===
Source: arcboot
Section: admin
Priority: optional
Maintainer: Guido Guenther <agx@debian.org>
Build-Depends: debhelper (>=4.1.16)
Build-Conflicts: e2fslibs-dev
Standards-Version: 3.6.1

Package: arcboot
Architecture: mips
Depends: ${misc:Depends}, dvhtool, file
Description: Bootloader for SGI/MIPS IP22 and IP32 machines
 arcboot is a bootloader for SGI/MIPS IP22 and IP32 machines like the Indy,
 Indigo2 and O2. It is able to boot the Linux kernel from ext2 and ext3
 filesystems which makes putting the kernel into the volume header obsolete.
 Support for other ARCS based subarches can easily be added.
 It is currently not capable of booting IRIX or to boot from iso9660 CDROMs
 though.

Package: tip22
Architecture: mips
Depends: ${misc:Depends}, binutils | binutils-multiarch
Description: Tftp boot image builder for SGI/MIPS IP22 machines
 tip22 is used to merge kernel and initrd into one bootable ecoff image. This
 image also contains a small bootloader that copies the kernel to it's
 loadaddress and appends the ramdisk. This is useful for booting via tftp or
 from a CDROM. It is currently targeted for the IP22 subarchitecture but
 support for other ARCS based subarchitectures and output formats can easily be
 added.

=== debian/rules ===
--- 
+++ 
@@ -26,12 +26,12 @@
 	# update the version string
 	echo "#define __ARCSBOOT_VERSION__ \"${realver}\"" > common/version.h
 	# build the package
-	make CC=gcc-2.95 build-subarch-indep
+	make build-subarch-indep
 	make clean-subarch
-	make CC=gcc-2.95 SUBARCH=IP32
+	make SUBARCH=IP32
 	cp ext2load/ext2load arcboot.ip32
 	make clean-subarch
-	make CC=gcc-2.95 SUBARCH=IP22
+	make SUBARCH=IP22
 	cp ext2load/ext2load arcboot.ip22
 	touch build-stamp

## arcboot 0.3.8.6

=== Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
# Copyright 2002-2004 Guido Guenther <agx@sigxcpu.org>
# Copyright (C) 2004 by Thiemo Seufer
#  

# default subarch
SUBARCH ?= IP22

# these contain subarch independent files
SUBARCH_INDEP_DIRS=	\
	arclib		\
	e2fslib/util 	\
	e2fslib/et 	\
	e2fslib		\
	tip22

# these contain subarch dependent files
SUBARCH_DIRS=		\
	common		\
	ext2load

define indep-tgt
$(foreach sd,$(SUBARCH_INDEP_DIRS),$(1)-subarch-indep-$(sd))
endef

define dep-tgt
$(foreach sd,$(SUBARCH_DIRS),$(1)-subarch-dep-$(sd))
endef

define build-indep-tgt
$(call indep-tgt,build)
endef

define build-dep-tgt
$(call dep-tgt,build)
endef

define install-indep-tgt
$(call indep-tgt,install)
endef

define install-dep-tgt
$(call dep-tgt,install)
endef

define clean-indep-tgt
$(call indep-tgt,clean)
endef

define clean-dep-tgt
$(call dep-tgt,clean)
endef

define submake
@$(MAKE) -C $(1) SUBARCH=$(SUBARCH) $(2)
endef


all: build

build: build-subarch-indep build-subarch-dep
build-subarch-indep: $(build-indep-tgt)
build-subarch-dep: $(build-dep-tgt)

$(build-indep-tgt):
	$(call submake,$(patsubst build-subarch-indep-%,%,$@),all)

$(build-dep-tgt):
	$(call submake,$(patsubst build-subarch-dep-%,%,$@),all)

install: install-subarch-indep install-subarch-dep
install-subarch-indep: $(install-indep-tgt)
install-subarch-dep: $(install-dep-tgt)

$(install-indep-tgt):
	$(call submake,$(patsubst install-subarch-indep-%,%,$@),install)

$(install-dep-tgt):
	$(call submake,$(patsubst install-subarch-dep-%,%,$@),install)

clean: clean-subarch-indep clean-subarch-dep
clean-subarch-indep: $(clean-indep-tgt)
clean-subarch-dep: $(clean-dep-tgt)

$(clean-indep-tgt):
	$(call submake,$(patsubst clean-subarch-indep-%,%,$@),clean)

$(clean-dep-tgt):
	$(call submake,$(patsubst clean-subarch-dep-%,%,$@),clean)


.PHONY: all \
	build build-subarch-indep build-subarch-dep \
	$(build-indep-tgt) $(build-dep-tgt) \
	clean clean-subarch-indep clean-subarch-dep \
	$(clean-indep-tgt) $(clean-dep-tgt)

=== common/Makefile ===
SUBARCH ?= IP22

CFLAGS += -Wall -O2 -I. -I../arclib -DSUBARCH=${SUBARCH}

HOSTCC = $(CC)
HOSTCFLAGS += -Wall -O2 -DSUBARCH=$(SUBARCH)

all: print_loadaddr

print_loadaddr: print_loadaddr.c subarch.h version.h
	$(HOSTCC) $(HOSTCFLAGS) -o $@ $<

install: print_loadaddr

clean:
	rm -f print_loadaddr *~ tags

=== ext2load/Makefile ===
#
# Copyright 1999 Silicon Graphics, Inc.
#           2001-04 Guido Guenther <agx@sigxcpu.org>
#

SUBARCH ?= IP22

COMMONDIR = ../common

E2FSLIBDIR = ../e2fslib
EXT2LIB = $(E2FSLIBDIR)/libext2fs.a

ARCLIBDIR = ../arclib
ARCLIB = $(ARCLIBDIR)/libarc.a

OBJECTS = loader.o ext2io.o conffile.o
LIBS = $(EXT2LIB) $(ARCLIB)
TARGETS = ext2load 

CFLAGS = -O2 -I $(COMMONDIR) -I$(ARCLIBDIR) -I$(E2FSLIBDIR) 	\
         -Wall -mno-abicalls -G 0 -fno-pic			\
	 -DSUBARCH=${SUBARCH}

# uncomment for debugging
#CFLAGS+=-DDEBUG

LD = ld
LDFLAGS = -N -T ld.script

all:  $(TARGETS)

ext2load:  $(OBJECTS) $(LIBS) ld.script ../common/subarch.h
	rm -f $@
	$(LD) $(LDFLAGS) -o $@ $(OBJECTS) $(LIBS)

ld.script: ld.script.in
	$(MAKE) -C ../common SUBARCH=$(SUBARCH) print_loadaddr
	LOADADDR=$$(../common/print_loadaddr $(SUBARCH));	 	\
	OUTPUTFORMAT=$$(../common/print_outputformat $(SUBARCH));	\
	sed -e "s/@@LOADADDR@@/$$LOADADDR/"				\
	-e "s/@@OUTPUTFORMAT@@/$$OUTPUTFORMAT/" <$< >$@

install:

clean:
	rm -f $(TARGETS) *.a *.o tags ld.script

=== tip22/Makefile ===
#
# Copyright 2002-2004 Guido Guenther <agx@sigxcpu.org>
#

ARCLIBDIR = ../arclib
ARCLIB = $(ARCLIBDIR)/libarc.a

COMMONDIR = ../common
PRINT_LOADADDR = $(COMMONDIR)/print_loadaddr
PRINT_OUTPUTFORMAT = $(COMMONDIR)/print_outputformat

CFLAGS += -O2 -I$(COMMONDIR) -I$(ARCLIBDIR) -Wall -mno-abicalls -G 0 \
	-fno-pic -DSUBARCH=${SUBARCH}

ASFLAGS = -O2 -mno-abicalls -G 0 -fno-pic

LIBDIR ?= /usr/lib/tip22
BINDIR ?= /usr/sbin

LIBS=${ARCLIB}
BINS=tip22 tip32
LD_SCRIPTS = ld.kernel.script.$(SUBARCH) ld.ramdisk.script.$(SUBARCH) ld.script.$(SUBARCH)
OBJECTS = tftpload.$(SUBARCH).o
TARGETS = $(OBJECTS) $(LD_SCRIPTS)

# uncomment for debugging
#CFLAGS+=-DDEBUG


all: ${LIBS} ${BINS}
	@$(MAKE) SUBARCH=IP32 archall
	@$(MAKE) SUBARCH=IP22 archall

archall: $(TARGETS)


$(ARCLIB):
	@$(MAKE) -C $(ARCLIBDIR)

$(PRINT_LOADADDR):
	@$(MAKE) -C $(COMMONDIR) SUBARCH=$(SUBARCH)


%.$(SUBARCH).o: %.c
	$(CC) $(CFLAGS) -c -o $@ $<

%.script.$(SUBARCH): %.script.in $(PRINT_LOADADDR) $(PRINT_OUTPUTFORMAT)
	LOADADDR=$$($(PRINT_LOADADDR) $(SUBARCH));	 	\
	OUTPUTFORMAT=$$($(PRINT_OUTPUTFORMAT) $(SUBARCH));	\
	sed -e "s/@@LOADADDR@@/$$LOADADDR/"			\
	-e "s/@@OUTPUTFORMAT@@/$$OUTPUTFORMAT/" <$< >$@

clean:
	@$(MAKE) SUBARCH=IP32 archclean
	@$(MAKE) SUBARCH=IP22 archclean
	rm -f tags *~

archclean:
	@$(MAKE) -C $(ARCLIBDIR) clean
	@$(MAKE) -C $(COMMONDIR) clean
	rm -f $(TARGETS)

install: all
	install -d ${PREFIX}/${BINDIR}
	install -m 755 ${BINS} ${PREFIX}/${BINDIR}
	@$(MAKE) SUBARCH=IP32 archinstall
	@$(MAKE) SUBARCH=IP22 archinstall

archinstall:
	$(foreach tg,$(TARGETS),install -m 644 $(tg) ${PREFIX}/${LIBDIR};)


.PHONY: all archall clean archclean install archinstall

=== e2fslib/util/Makefile ===
# Generated automatically from Makefile.in by configure.
#
# Standard e2fsprogs prologue....
#

srcdir = .
top_srcdir = ..
top_builddir = ..
my_dir = util
INSTALL = /usr/bin/install -c

SRCS = $(srcdir)/subst.c


# Beginning of file MCONFIG

all::

check::

SHELL = /bin/sh

prefix = /usr
root_prefix = 
exec_prefix = ${prefix}
root_bindir = $(root_prefix)/bin
root_sbindir = $(root_prefix)/sbin
root_libdir = $(root_prefix)/lib
bindir = ${exec_prefix}/bin
sbindir = ${exec_prefix}/sbin
libdir = ${exec_prefix}/lib
includedir = ${prefix}/include
mandir = ${prefix}/man
man1dir = $(mandir)/man1
man3dir = $(mandir)/man3
man8dir = $(mandir)/man8
infodir = ${prefix}/info
datadir = ${prefix}/share



INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644
CC = cc
BUILD_CC = cc
DEFS =  -DENABLE_SWAPFS=1 -DPACKAGE=\"e2fsprogs\" -DVERSION=\"1.25\" -DSTDC_HEADERS=1 -DHAVE_ALLOCA_H=1 -DHAVE_ALLOCA=1 -DHAVE_UNISTD_H=1 -DHAVE_GETPAGESIZE=1 -DHAVE_MMAP=1 -DHAVE_ARGZ_H=1 -DHAVE_LIMITS_H=1 -DHAVE_LOCALE_H=1 -DHAVE_NL_TYPES_H=1 -DHAVE_MALLOC_H=1 -DHAVE_STRING_H=1 -DHAVE_UNISTD_H=1 -DHAVE_SYS_PARAM_H=1 -DHAVE_GETCWD=1 -DHAVE_MUNMAP=1 -DHAVE_PUTENV=1 -DHAVE_SETENV=1 -DHAVE_SETLOCALE=1 -DHAVE_STRCHR=1 -DHAVE_STRCASECMP=1 -DHAVE_STRDUP=1 -DHAVE___ARGZ_COUNT=1 -DHAVE___ARGZ_STRINGIFY=1 -DHAVE___ARGZ_NEXT=1 -DHAVE_STPCPY=1 -DHAVE_STPCPY=1 -DHAVE_LC_MESSAGES=1 -DHAVE_STDLIB_H=1 -DHAVE_UNISTD_H=1 -DHAVE_STDARG_H=1 -DHAVE_ERRNO_H=1 -DHAVE_MALLOC_H=1 -DHAVE_MNTENT_H=1 -DHAVE_PATHS_H=1 -DHAVE_DIRENT_H=1 -DHAVE_GETOPT_H=1 -DHAVE_SETJMP_H=1 -DHAVE_SIGNAL_H=1 -DHAVE_TERMIOS_H=1 -DHAVE_LINUX_FD_H=1 -DHAVE_LINUX_MAJOR_H=1 -DHAVE_SYS_IOCTL_H=1 -DHAVE_SYS_MOUNT_H=1 -DHAVE_SYS_SYSMACROS_H=1 -DHAVE_SYS_TIME_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_NET_IF_H=1 -DHAVE_NETINET_IN_H=1 -DHAVE_VPRINTF=1 -DHAVE_LSEEK64_PROTOTYPE=1 -DSIZEOF_SHORT=2 -DSIZEOF_INT=4 -DSIZEOF_LONG=4 -DSIZEOF_LONG_LONG=8 -DWORDS_BIGENDIAN=1 -DHAVE_GETRUSAGE=1 -DHAVE_LLSEEK=1 -DHAVE_LSEEK64=1 -DHAVE_OPEN64=1 -DHAVE_STRCASECMP=1 -DHAVE_SRANDOM=1 -DHAVE_FCHOWN=1 -DHAVE_MALLINFO=1 -DHAVE_FDATASYNC=1 -DHAVE_STRNLEN=1 -DHAVE_EXT2_IOCTLS=1 
CFLAGS = -g -O2
CPPFLAGS = 
ALL_CFLAGS = $(CPPFLAGS) $(DEFS) $(USE_WFLAGS) $(CFLAGS) $(XTRA_CFLAGS) \
	-I$(top_builddir)/lib -I$(top_srcdir)/lib \
	-I$(top_srcdir)/include $(LINUX_INCLUDE) 
LDFLAGS = 
ALL_LDFLAGS = $(LDFLAGS)
RM = /bin/rm
LN = /bin/ln
LN_S = ln -s
MV = /bin/mv
CP = /bin/cp
CHMOD = /bin/chmod
AR = ar
AWK = /usr/bin/awk
SED = /bin/sed
PERL = /usr/bin/perl
RANLIB = ranlib
STRIP = strip
LD = $(PURE) cc
ARUPD = $(AR) r
LDCONFIG = :

#
# Library definitions
#
LIB = $(top_builddir)/lib
LIBSS = $(LIB)/libss.a
LIBCOM_ERR = $(LIB)/libcom_err.a
LIBE2P = $(LIB)/libe2p.a
LIBEXT2FS = $(LIB)/libext2fs.a
LIBUUID = $(LIB)/libuuid.a  
DEPLIBUUID = $(LIB)/libuuid.a

STATIC_LIBSS = $(LIB)/libss.a
STATIC_LIBCOM_ERR = $(LIB)/libcom_err.a
STATIC_LIBE2P = $(LIB)/libe2p.a
STATIC_LIBEXT2FS = $(LIB)/libext2fs.a
STATIC_LIBUUID = $(LIB)/libuuid.a  
DEPSTATIC_LIBUUID = $(LIB)/libuuid.a

PROFILED_LIBSS = $(LIB)/libss
PROFILED_LIBCOM_ERR = $(LIB)/libcom_err
PROFILED_LIBE2P = $(LIB)/libe2p
PROFILED_LIBEXT2FS = $(LIB)/libext2fs
PROFILED_LIBUUID = $(LIB)/libuuid  
DEPPROFILED_LIBUUID = $(LIB)/libuuid

#
# Use these definitions is you use tools 2.x, x < 16
#
#DLL_BIN=/usr/dll/bin
#JUMP_PREFIX=/usr/dll/jump/

#
# Use these definitions if you use tools 2.16 or above
#
DLL_BIN=/usr/bin
JUMP_PREFIX=/usr/bin/jump

# An include directive pointing to a directory holding enough linux-like
# include files to satisfy some programs here
LINUX_INCLUDE=

#
# A fast substitution command for fixing up man pages, shell scripts, etc.
#
SUBST_CONF=$(top_builddir)/util/subst.conf
SUBSTITUTE= $(top_builddir)/util/subst -f $(SUBST_CONF)
DEP_SUBSTITUTE= $(top_builddir)/util/subst $(SUBST_CONF)

$(top_builddir)/util/subst:
	cd $(top_builddir)/util ; $(MAKE) subst

#
# Warning flags
#
# Run make gcc-wall to do a build with warning messages.
#
#
WFLAGS=		-ansi -D_POSIX_SOURCE -pedantic \
			-Wall -Wwrite-strings -Wpointer-arith \
			-Wcast-qual -Wcast-align -Wtraditional \
			-Wstrict-prototypes -Wmissing-prototypes \
			-Wnested-externs -Winline -DNO_INLINE_FUNCS -Wshadow 

gcc-wall-new:
	(make USE_WFLAGS="$(WFLAGS)" > /dev/null) 2>&1 | sed -f $(top_srcdir)/util/gcc-wall-cleanup 

gcc-wall:
	make clean > /dev/null
	make gcc-wall-new

#
# Installation user and groups
#
BINGRP=		bin
BINOWN=		bin
BINMODE=	555
INCGRP=		bin
INCOWN=		bin
INCMODE=	444
LIBOWN=		bin
LIBGRP=		bin
LIBMODE=	444
MANGRP=		bin
MANOWN=		bin
MANMODE=	444

#
# Autoconf magic...
#

DEP_LIB_MAKEFILES = $(top_srcdir)/lib/Makefile.elf-lib  \
	$(top_srcdir)/lib/Makefile.dll-lib $(top_srcdir)/lib/Makefile.bsd-lib \
	$(top_srcdir)/lib/Makefile.checker $(top_srcdir)/lib/Makefile.profile

$(top_builddir)/config.status: $(top_srcdir)/configure
	cd $(top_builddir); ./config.status --recheck

$(top_builddir)/lib/substitute_sh: $(top_srcdir)/lib/substitute_sh.in \
		$(top_builddir)/config.status
	cd $(top_builddir); CONFIG_FILES=lib/substitute_sh ./config.status

$(top_builddir)/util/subst.conf: $(top_srcdir)/util/subst.conf.in \
		$(top_builddir)/config.status
	cd $(top_builddir); CONFIG_FILES=util/subst.conf ./config.status

$(top_srcdir)/configure: $(top_srcdir)/configure.in
	cd $(top_srcdir) && autoconf

#
# Make depend magic...
#

.depend: Makefile $(SRCS) $(top_srcdir)/depfix.sed $(top_srcdir)/wordwrap.pl
	if test -n "$(SRCS)" ; then \
		$(CC) -M $(ALL_CFLAGS) $(SRCS) | \
			$(SED) -f $(top_srcdir)/depfix.sed \
			    -e 's; $(srcdir)/; $$(srcdir)/;g' \
			    -e 's; $(top_srcdir)/; $$(top_srcdir)/;g' \
			    -e 's; $(top_builddir)/; $$(top_builddir)/;g' \
			    -e 's; \./; ;g' \
			    -e '/^ *\\$$/d' | \
			$(PERL) $(top_srcdir)/wordwrap.pl > .depend; \
	else :; fi

depend:: .depend
	if test -n "$(SRCS)" ; then \
		sed -e '/^# +++ Dependency line eater +++/,$$d' \
			< $(srcdir)/Makefile.in | cat - .depend \
			> $(srcdir)/Makefile.in.new; \
	if cmp -s $(srcdir)/Makefile.in $(srcdir)/Makefile.in.new ; then \
		$(RM) $(srcdir)/Makefile.in.new ; \
	else \
		$(MV) $(srcdir)/Makefile.in $(srcdir)/Makefile.in.old; \
		$(MV) $(srcdir)/Makefile.in.new $(srcdir)/Makefile.in; \
	fi ; else :; fi

# End of file MCONFIG

.c.o:
	$(BUILD_CC) -c $(ALL_CFLAGS) $< -o $@

PROGS=		subst

all:: $(PROGS)

subst: subst.o
	$(BUILD_CC) $(ALL_LDFLAGS) -o subst subst.o

clean:
	$(RM) -f $(PROGS) \#* *.s *.o *.a *~ core

mostlyclean: clean

distclean: clean
	$(RM) -f .depend Makefile $(srcdir)/TAGS $(srcdir)/Makefile.in.old

# +++ Dependency line eater +++
# 
# Makefile dependencies follow.  This must be the last section in
# the Makefile.in file
#
subst.o: $(srcdir)/subst.c

=== debian/changelog ===
arcboot (0.3.8.6) unstable; urgency=low

  * Allow ELF64 kernels for tip22/tip32.

 -- Thiemo Seufer <ths@debian.org>  Sun, 06 Feb 2005 01:51:01 +0100

arcboot (0.3.8.5) unstable; urgency=low

  * Add da debconf translation by Morten Brix Pedersen, thanks
    (Closes: #276691).
  * Add tip32 for IP32 machines.
  * Rework build system.
  * Vastly improved loader performance, thanks Keith Wesolowski.

 -- Thiemo Seufer <ths@debian.org>  Mon, 31 Jan 2005 21:24:00 +0100

=== debian/control ===
Source: arcboot
Section: admin
Priority: optional
Maintainer: Guido Guenther <agx@debian.org>
Uploaders: Thiemo Seufer <ths@debian.org>
Build-Depends: debhelper (>=4.1.16)
Build-Conflicts: e2fslibs-dev
Standards-Version: 3.6.1

Package: arcboot
Architecture: mips
Depends: dvhtool
Description: Bootloader for SGI/MIPS IP22 and IP32 machines
 arcboot is a bootloader for SGI/MIPS IP22 and IP32 machines like the Indy,
 Indigo2 and O2. It is able to boot the Linux kernel from ext2 and ext3
 filesystems. Support for other ARCS based subarchitectures can easily be
 added. It is currently not capable of booting IRIX or to boot from iso9660
 CDROMs though.

Package: tip22
Architecture: mips
Depends: binutils | binutils-multiarch, file
Description: Tftp boot image builder for SGI/MIPS IP22 and IP32 machines
 tip22 is used to merge kernel and initrd into one bootable image. This
 image also contains a small loader stub that copies the kernel to its
 load address and appends the ramdisk. This is useful for booting via tftp or
 from a CDROM. It is currently targeted for the IP22 and IP32 subarchitectures
 but support for other ARCS based subarchitectures can easily be added.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,12 @@
 realver := $(shell dpkg-parsechangelog | awk -F' ' '/^Version:/ {print $$2}' | awk -F- '{print $$1}')
 
 PREFIX_ARCB=${CURDIR}/debian/arcboot
+BIN_ARCB=usr/sbin
+LIB_ARCB=usr/lib/arcboot
+
 PREFIX_TIP22=${CURDIR}/debian/tip22
+BIN_TIP22=usr/sbin
+LIB_TIP22=usr/lib/tip22
 
 architecture=$(dpkg --print-architecture)
 
@@ -26,12 +31,12 @@
 	# update the version string
 	echo "#define __ARCSBOOT_VERSION__ \"${realver}\"" > common/version.h
 	# build the package
-	make build-subarch-indep
-	make clean-subarch
-	make SUBARCH=IP32
+	$(MAKE) build-subarch-indep
+	$(MAKE) clean-subarch-dep
+	$(MAKE) SUBARCH=IP32 build-subarch-dep
 	cp ext2load/ext2load arcboot.ip32
-	make clean-subarch
-	make SUBARCH=IP22
+	$(MAKE) clean-subarch-dep
+	$(MAKE) SUBARCH=IP22 build-subarch-dep
 	cp ext2load/ext2load arcboot.ip22
 	touch build-stamp
 
@@ -53,12 +58,13 @@
 	dh_installdirs
 
 	# install arcboot into debian/arcboot
-	install -m 644 arcboot.ip22 ${PREFIX_ARCB}/usr/lib/arcboot/arcboot.ip22
-	install -m 644 arcboot.ip32 ${PREFIX_ARCB}/usr/lib/arcboot/arcboot.ip32
-	install -m 755 scripts/arcboot ${PREFIX_ARCB}/usr/sbin/arcboot
+	install -m 644 arcboot.ip22 ${PREFIX_ARCB}/${LIB_ARCB}/arcboot.ip22
+	install -m 644 arcboot.ip32 ${PREFIX_ARCB}/${LIB_ARCB}/arcboot.ip32
+	install -m 755 scripts/arcboot ${PREFIX_ARCB}/${BIN_ARCB}/arcboot
 
 	# install tip22 into debian/tip22
-	make PREFIX=${PREFIX_TIP22} -C tip22 install
+	$(MAKE) PREFIX=${PREFIX_TIP22} BINDIR=${BIN_TIP22} LIBDIR=${LIB_TIP22} -C arclib install
+	$(MAKE) PREFIX=${PREFIX_TIP22} BINDIR=${BIN_TIP22} LIBDIR=${LIB_TIP22} -C tip22 install
 
 # Build architecture-independent files here.
 binary-indep: build install

## arcboot 0.3.8.7

=== debian/changelog ===
arcboot (0.3.8.7) unstable; urgency=low

  * Add vietnamese translation, thanks Clytie Siddall (Closes: #313114).
  * Add czech translation, thanks Miroslav Kure (Closes: #317662).
  * Switch from the local e2fslib to the up-to-date libext2fs-nopic.a
    in Debian, but don't delete the old version for now.
  * Avoid inclusion of kernel headers.

 -- Thiemo Seufer <ths@debian.org>  Sat, 17 Sep 2005 20:15:35 +0200

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,8 @@
 Priority: optional
 Maintainer: Guido Guenther <agx@debian.org>
 Uploaders: Thiemo Seufer <ths@debian.org>
-Build-Depends: debhelper (>=4.1.16)
-Build-Conflicts: e2fslibs-dev
-Standards-Version: 3.6.1
+Build-Depends: debhelper (>=4.1.16), e2fslibs-dev
+Standards-Version: 3.6.2
 
 Package: arcboot
 Architecture: mips
